package data_manage

import (
	"rdluck_tools/orm"
	"time"
)

type EdbInfoList struct {
	EdbInfoId  int       `orm:"column(edb_info_id);pk"`
	SourceName string    `description:"来源名称"`
	Source     int       `description:"来源id"`
	EdbCode    string    `description:"指标编码"`
	EdbName    string    `description:"指标名称"`
	Frequency  string    `description:"频率"`
	Unit       string    `description:"单位"`
	StartDate  time.Time `description:"起始日期"`
	EndDate    time.Time `description:"终止日期"`
	ClassifyId int       `description:"分类id"`
	UniqueCode string    `description:"指标唯一编码"`
}

func GetEdbInfoByCondition(condition string, pars []interface{}) (item []*EdbInfoList, err error) {
	o := orm.NewOrm()
	o.Using("data")
	sql := ` SELECT * FROM edb_info WHERE 1=1 `
	if condition != "" {
		sql += condition
	}
	_,err = o.Raw(sql, pars).QueryRows(&item)
	return
}

func ModifyEdbDataInfoDate(edbInfoId int, maxDate string) (err error) {
	o := orm.NewOrm()
	o.Using("data")
	sql := ` UPDATE edb_info SET end_date=?,modify_time=NOW() WHERE edb_info_id=? `
	_, err = o.Raw(sql, maxDate, edbInfoId).Exec()
	return
}
