package services

import (
	"fmt"
	"github.com/astaxie/beego/toolbox"
	"hongze/hongze_task/services/data_manage"
	"hongze/hongze_task/services/company_contract"
	"hongze/hongze_task/utils"
)

func Task() {
	fmt.Println("task start")
	//如果是生产环境，才需要走这些任务
	if utils.RunMode == "release"{
		releaseTask()
	}
	//每日定时合同处理
	handleCompanyContract := toolbox.NewTask("handleCompanyContract", "0 1 0 * * *", company_contract.HandleCompanyContract)
	toolbox.AddTask("每日定时合同处理", handleCompanyContract)

	//正式->试用
	companyTryOut := toolbox.NewTask("companyTryOut", "0 5 0 * * *", CompanyTryOut)
	toolbox.AddTask("正式->试用", companyTryOut)

	//试用->冻结
	companyFreeze := toolbox.NewTask("companyFreeze", "0 10 0 * * *", CompanyFreeze)
	toolbox.AddTask("试用->冻结", companyFreeze)

	//冻结->流失
	companyLoss := toolbox.NewTask("companyLoss", "0 20 0 * * *", CompanyLoss)
	toolbox.AddTask("冻结->流失", companyLoss)

	//用户产品权限试用-->关闭
	companyReportPermissionClose := toolbox.NewTask("companyReportPermissionClose", "0 30 0 * * *", CompanyReportPermissionClose)
	toolbox.AddTask("用户产品权限试用-->关闭", companyReportPermissionClose)

	//删除日志记录
	//deleteReportSaveLog := toolbox.NewTask("deleteReportSaveLog", "0 30 08 * * *", DeleteReportSaveLog)
	//toolbox.AddTask("deleteReportSaveLog", deleteReportSaveLog)


	// 存量客户数据统计
	stackCompanyStatistic := toolbox.NewTask("stackCompanyStatistic", "0 35 0 * * *", StackCompanyStatistic)
	toolbox.AddTask("存量客户数据统计", stackCompanyStatistic)

	toolbox.StartTask()
	//GetHistoryLzProductDetail()
	//GetLzPrice()
	//GetLzProductDetail()
	//LzExportExcel()
	//GetLzProductList()GetLzProductDetail
	fmt.Println("task end")
}

//生产环境需要走的任务
func releaseTask(){

	//隆众指标获取
	getLzProductList := toolbox.NewTask("getLzProductList", "0 0 11-19/1 * * * ", GetLzProductList)
	toolbox.AddTask("getLzProductList", getLzProductList)
	//隆众指标数据获取
	getLzProductDetail := toolbox.NewTask("getLzProductDetail", "0 5 11-19/1 * * * ", GetLzProductDetail)
	toolbox.AddTask("getLzProductDetail", getLzProductDetail)

	//隆众价格指标获取
	getLzProductPriceProduct := toolbox.NewTask("getLzProductPriceProduct", "0 5 11-19/1 * * * ", GetLzProductPriceProduct)
	toolbox.AddTask("getLzProductPriceProduct", getLzProductPriceProduct)
	//隆众价格指标数据获取
	getLzProductPriceData := toolbox.NewTask("getLzProductPriceData", "0 10 11-19/1 * * * ", GetLzProductPriceData)
	toolbox.AddTask("getLzProductPriceData", getLzProductPriceData)

	//发送邮件
	sendEmail := toolbox.NewTask("sendEmail", "0 0 12 * * 0 ", SendEmail)
	toolbox.AddTask("sendEmail", sendEmail)

	oneMinute := toolbox.NewTask("oneMinute", "0 */1 7-23 * * * ", OneMinute)
	toolbox.AddTask("oneMinute", oneMinute)

	// 正式/试用 用户到期提醒
	companyRemind := toolbox.NewTask("companyRemind", "0 30 08 * * *", CompanyRemind)
	toolbox.AddTask("companyRemind", companyRemind)

	//潜在客户
	freeViewerDetail := toolbox.NewTask("freeViewerDetail", "0 0 9 * * 1 ", FreeViewerDetail)
	toolbox.AddTask("潜在客户", freeViewerDetail)

	//刷新数据
	refreshData := toolbox.NewTask("refreshData", "0 0 18 * * *", RefreshData)
	toolbox.AddTask("refreshData", refreshData)

	checkDataInterface := toolbox.NewTask("checkDataInterface", "0 */3 * * * * ", data_manage.CheckDataInterface)
	toolbox.AddTask("checkDataInterface", checkDataInterface)

	checkPbDataInterface := toolbox.NewTask("checkPbDataInterface", "0 */5 * * * * ", data_manage.CheckPbDataInterface)
	toolbox.AddTask("checkPbDataInterface", checkPbDataInterface)
}

func TaskTest(){
	fmt.Println("The task is start")
	//companyReportPermissionClose := toolbox.NewTask("companyTryOut", "0 5 0 * * *", CompanyReportPermissionClose)
	companyReportPermissionClose := toolbox.NewTask("companyReportPermissionClose", "0/30 * * * * *", CompanyReportPermissionClose)
	toolbox.AddTask("用户产品权限试用-->关闭", companyReportPermissionClose)
	toolbox.StartTask()
	fmt.Println("The task is end")
}

func Task123() {
	fmt.Println("start")
	//FreeViewerDetail()
	HongzeUsers()
	fmt.Println("end")
	return
}

func SendEmail() (err error) {
	//报告历史访问次数
	go ReportViewTimes()
	//报告访问详情
	go ReportViewDetail()
	//用户权限统计
	go HongzeUsers()
	return
}

func OneMinute() (err error) {
	//日度
	//FrequencyByDay()
	//周度
	FrequencyByWeek()
	//月度
	FrequencyByMonth()
	return
}

func RefreshData() (err error){
	//wind
	go data_manage.RefreshDataFromWind()
	//同花顺
	go data_manage.RefreshDataFromThs()
	//彭博
	go data_manage.RefreshDataFromPb()
	return
}